#ifndef __LCD_H__
#define __LCD_H__

#if !defined(__KERNEL__)
#include <common.h>
#endif

/**** !!!NOTE!!! ************************
(linux-2.6.24.2/include/asm-arm/memory.h)

if LCD resolution is 800x480
"#define CONSISTENT_DMA_SIZE SZ_8M"

else
"#define CONSISTENT_DMA_SIZE SZ_2M"

***************************************/

#if !defined(__KERNEL__)	//bootloader
/***************************************************************************************
* Boot-logo Color Deapth (32bit:enable / 16bit:disable)
****************************************************************************************/
//#define _LCD_32BPP_

#endif


/***************************************************************************************
*  LCD Module Select
****************************************************************************************/
#if (defined(_LINUX_) && defined(TCC79X)) || (defined(__KERNEL__) && defined(_TCC79x_))

#if (defined(_LINUX_) && defined(_BOARD_VERSION_TCC7901S_PDK_DEMO_MV02_)) || (defined(__KERNEL__) && defined(CONFIG_MACH_TCC7901S))

/*========================================================
 * for TCC7901S Demo Board
 *======================================================*/

/* [TCC78/79/83_4.3"18B&SY_SV1.0]     (480x272) (18Bit) */
	#define	TCC78_79_83_4R3_18B_SY_SV1_0
	
/* [End] */

#else

/*========================================================
 * for TCC79XX Demo Board
 *======================================================*/

/* [TCC79XX_24bitLCD_SANYO_SUB_V0.11] (480x272) (24Bit) */
	#define	TCC79XX_24bitLCD_SANYO_SUB_V0_11

/* [TCC79XX_24bitLCD_SANYO_SUB_V0.11] (800x480) (24Bit) */
//	#define	TCC79XX_24bitLCD_SANYO_SUB_V0_11_800X480

/* [TCC79XX_LCD_4.8"WVGA&24B_SV0.1]   (800x480) (24Bit) */
//	#define	TCC79XX_LCD_4R8_WVGA_24B_SV0_1

/* [7 Inch LCD Module]                (800x480) (24Bit) */
//	#define	TCC79XX_7Inch_LCD_Module

/* [TCC78/79/83_4.3"18B&SY_SV1.0]     (480x272) (18Bit) */
//	#define	TCC78_79_83_4R3_18B_SY_SV1_0

/* [TCC8300_18bit_LCD_SANYO_SUB_V1.0] (480x272) (18Bit) */
//	#define	TCC8300_18bit_LCD_SANYO_SUB_V1_0

/* [TCC7800_LCD_IMAGIS_SUB_V0.21]     (480x272) (18Bit) */
//	#define	TCC7800_LCD_IMAGIS_SUB_V0_21

/* [End] */
#endif
#elif (defined(_LINUX_) && defined(TCC83XX)) || (defined(__KERNEL__) && defined(_TCC83x_))

/*========================================================
 * for TCC83XX Demo Board
 *======================================================*/

/* [TCC8300_18bit_LCD_SANYO_SUB_V1.0] (480x272) (18Bit) */
	#define	TCC8300_18bit_LCD_SANYO_SUB_V1_0
//
/* [TCC7800_LCD_IMAGIS_SUB_V0.21]     (480x272) (18Bit) */
//	#define	TCC7800_LCD_IMAGIS_SUB_V0_21

/* [End] */

#endif


/***************************************************************************************
* 
****************************************************************************************/
// LCD RRB Bitcount define
#if defined(_LCD_32BPP_)
	#define LCD_RGB_BITCOUNT	4
#else
	#define LCD_RGB_BITCOUNT	2
#endif

// LCD_Model/RGB_Interface define
#if   defined(TCC79XX_24bitLCD_SANYO_SUB_V0_11)
	#define _LCD_480X272_LTE430WQ_F0C_
	#define _LCD_RGBIF_24BITS_

#elif defined(TCC78_79_83_4R3_18B_SY_SV1_0)
	#define	_LCD_480X272_LTE430WQ_F0C_
	#define _LCD_RGBIF_18BITS_
	
#elif defined(TCC8300_18bit_LCD_SANYO_SUB_V1_0)
	#define	_LCD_480X272_LTE430WQ_F0C_
	#define _LCD_RGBIF_18BITS_
	#define _SAMSUNG_24BIT_
	
#elif defined(TCC7800_LCD_IMAGIS_SUB_V0_21)
	#define	_LCD_480X272_LQ043T3DX04_
	#define _LCD_RGBIF_18BITS_
//	#define _SAMSUNG_24BIT_	// undefine!
	
#elif defined(TCC79XX_24bitLCD_SANYO_SUB_V0_11_800X480)
	#define	_LCD_800X480_4R3_INCH_
	#define _LCD_RGBIF_24BITS_
	
#elif defined(TCC79XX_LCD_4R8_WVGA_24B_SV0_1)
	#define	_LCD_800X480_LMS480KF02_4R8_INCH_
	#define _LCD_RGBIF_24BITS_
	
#elif defined(TCC79XX_7Inch_LCD_Module)
	#define	_LCD_800X480_LTP700WV_INCH_
	#define _LCD_RGBIF_24BITS_

#endif


#if   defined(_LCD_480X272_LTE430WQ_F0C_)	//default

	//resolution
	#define _LCD_480X272_
	//clock devide
	#define LCD_DEVIDE		8
	//timing
	#define	LCD_VPW			(11)	// Vertical Pulse Width
	#define	LCD_VBP			( 1)	// Vertical Back Porch
	#define	LCD_VFP			( 1)	// Vertical Front Porch
	#define	LCD_HPW			(41)	// Horizontal Pulse Width
	#define	LCD_HBP			( 1)	// Horizontal Back Porch
	#define	LCD_HFP			( 1)	// Horizontal Front Porch

#elif defined(_LCD_480X272_LQ043T3DX04_)	//78x

	//resolution
	#define _LCD_480X272_
	//clock devide
	#define LCD_DEVIDE		8
	//timing
	#define	LCD_VPW			(11)	// Vertical Pulse Width
	#define	LCD_VBP			( 1)	// Vertical Back Porch
	#define	LCD_VFP			( 1)	// Vertical Front Porch
	#define	LCD_HPW			(41)	// Horizontal Pulse Width
	#define	LCD_HBP			( 1)	// Horizontal Back Porch
	#define	LCD_HFP			( 1)	// Horizontal Front Porch

#elif defined(_LCD_800X480_4R3_INCH_)

	//resolution
	#define _LCD_800X480_
	//clock devide
	#define LCD_DEVIDE		3
	//timing
	#define	LCD_VPW			( 8)	// Vertical Pulse Width
	#define	LCD_VBP			(25)	// Vertical Back Porch
	#define	LCD_VFP			( 2)	// Vertical Front Porch
	#define	LCD_HPW			(20)	// Horizontal Pulse Width
	#define	LCD_HBP			(86)	// Horizontal Back Porch
	#define	LCD_HFP			(40)	// Horizontal Front Porch

#elif defined(_LCD_800X480_LMS480KF02_4R8_INCH_)

	//resolution
	#define _LCD_800X480_
	//clock devide
	#define LCD_DEVIDE		3
	//timing
	#define	LCD_VPW			( 3)	// Vertical Pulse Width
	#define	LCD_VBP			( 5)	// Vertical Back Porch
	#define	LCD_VFP			( 5)	// Vertical Front Porch
	#define	LCD_HPW			( 3)	// Horizontal Pulse Width
	#define	LCD_HBP			(13)	// Horizontal Back Porch
	#define	LCD_HFP			( 8)	// Horizontal Front Porch

#elif defined(_LCD_800X480_LTP700WV_INCH_)

	//resolution
	#define _LCD_800X480_
	//clock devide
	#define LCD_DEVIDE		3
	//timing
	#define	LCD_VPW			( 3)	// Vertical Pulse Width
	#define	LCD_VBP			( 5)	// Vertical Back Porch
	#define	LCD_VFP			( 5)	// Vertical Front Porch
	#define	LCD_HPW			( 2)	// Horizontal Pulse Width
	#define	LCD_HBP			(14)	// Horizontal Back Porch
	#define	LCD_HFP			( 8)	// Horizontal Front Porch

#endif


#if defined(_LCD_800X480_)
	#define LCD_WIDTH       800
	#define LCD_HEIGHT      480
#else
	#define LCD_WIDTH       480
	#define LCD_HEIGHT      272
#endif



#define NAND_PAGE_SIZE          512
#define PROGRAM_BASE_ADDRESS    (0x20000000+KERNEL_START_OFFSET)
#define HIDDEN_OFFSET_OF_KERNEL	8	// Kernel Image Offset is Page #8 (4096 Bytes per Page)


#if		defined(_LINUX_)	// bootloader
	#define IMAGE1_START		((PROGRAM_BASE_ADDRESS-0x00100000)-(LCD_WIDTH*LCD_HEIGHT*LCD_RGB_BITCOUNT)-4)

#elif defined(__KERNEL__)	// Kernel
	#define IMAGE1_START		((((PROGRAM_BASE_ADDRESS-0x00100000)-(LCD_WIDTH*LCD_HEIGHT*LCD_RGB_BITCOUNT))|(0xA0000000))-4)

#endif

#endif /* __LCD_H__ */
