#ifdef __KERNEL__
#   if defined(_TCC79x_)
#       include <mach/tcc79x.h>
#   elif defined(_TCC83x_)
#       include <mach/tcc83x_virt.h>
#       include <mach/irqs.h>
#elif defined(CONFIG_ARCH_TCC92X)  //temp
#		include <mach/irqs.h>
#		include <mach/bsp.h>
#endif

#else
#   if defined(_TCC79x_)
#       include "TCC79x_Virtual.h"
#   elif defined(_TCC83x_)
#       include "TCC83x_Virtual.h"
#   elif defined(_TCC80x_)
#       include "TCC80x_Virtual.h"
#   endif
#endif

#if defined(CONFIG_ARCH_TCC92X)
#define TSC_EINT_PIN		Hw4
#define TSC_EINT_PORT_EN	HwGPIOA->GPEN
#define TSC_EINT_PORT_DAT	HwGPIOA->GPDAT
#define TSC_EINT_SEL		HwEINTSEL2_EINT11(SEL_GPIOA4)

#define TSC_EINT_SEL_MASK	HwEINTSEL2_EINT11_MASK
#define TSC_EINT_SEL_ID 	HwINT0_EI11

#endif


void tca_tchhw_enableirq(void)
{
#if defined(_TCC79x_)
	HwINTMSK |= HwINT_EI2; 
#elif defined(_TCC83x_)
	BITSET(HwCLR_B , HwIEN_EI2); 
	BITSET(HwIEN_B , HwIEN_EI2); 
	BITSET(HwIEN , Hw0); 
#elif defined(_TCC80x_)
	BITSET(HwCREQ_B , Hw7);  // PK[7] External Request 7 
	BITSET(HwIEN_B , Hw7);  // PK[7] External Request 7 
	BITSET(HwIRQSEL_B , Hw7);  // PK[7] 1, it means that the corresponding interrupt is considered as IRQ interrupt
#elif defined(CONFIG_ARCH_TCC92X)
	HwPIC->INTMSK0 |= TSC_EINT_SEL_ID;	   
#endif
}

void tca_tchhw_disableirq(void)
{
#if defined(_TCC79x_)
	HwINTMSK &= ~HwINT_EI2; 
#elif defined(_TCC83x_)
	BITCLR(HwIEN_B , HwIEN_EI2);
#elif defined(_TCC80x_)
	BITCLR(HwIEN_B , Hw7);  // PK[7] External Request 7 
#elif defined(CONFIG_ARCH_TCC92X)
	HwPIC->INTMSK0 &= ~TSC_EINT_SEL_ID;	   
#endif
}
unsigned int tca_tchhw_getirqnum(void)
{
#if defined(_TCC83x_)
#ifdef __KERNEL__
    return INT_EI2;
#endif
#elif defined(_TCC79x_)
	return IRQ_EI2;
#elif defined(_TCC80x_)
	return IRQ_EI7;
#elif defined(CONFIG_ARCH_TCC92X)
	return INT_EI11;
#endif
}
void tca_tchhw_initport(void)
{
#if defined(_TCC79x_)
#ifdef CONFIG_MACH_TCC7901S
	BITCSET(HwPORTCFG9, Hw20 - Hw16, Hw16);	
	BITCLR(HwGPEEN, Hw31);
	BITCSET(HwEINTSEL0, Hw21 - Hw16, Hw17);	
	BITSET(HwGPEDAT, Hw31);
#else
	//EINT_2 init
	BITCLR(HwPORTCFG4, Hw20 - Hw16);
	BITCLR(HwGPAEN, Hw2);
	BITCSET(HwEINTSEL0, Hw21 - Hw16, Hw20 | Hw17);	
#endif
    BITSET(HwSEL, HwINT_EI2);
    BITSET(HwIRQMSK, HwINT_EI2);

    BITSET(HwPOL, HwINT_EI2);
#ifdef __KERNEL__
    BITCLR(HwMODE, HwINT_EI2);
#else
    BITSET(HwMODE, HwINT_EI2);
#endif

#elif defined(_TCC83x_)
#ifdef __KERNEL__
//#       if defined(_AK4183_)
    BITCLR(HwGIOCON_B, Hw6);
    //EINT_2 init, GPIO_B6
    HwNGSEL_B &= ~(1<<6);
    HwGPIOB_PE |= (1<<6);
    HwGPIOB_PS |= (1<<6);
    HwGSEL_B |= HwGSEL_B_N1_EI2;

    BITCLR(HwICFG, Hw11);
    BITCLR(HwICFG, Hw10 | Hw9);

    //set IRQ as level sensitive; low active
    HwSEL_B |= HwSEL_EI2;
    HwIEN_B &= ~HwIEN_EI2;
    HwMODE_B |= HwMODE_EI2;
    HwSYNC_B |= HwSYNC_EI2;
#else
	//EINT_2 init
	BITSET(HwGSEL_B,    Hw4);  //GPIO_B6 setting GPIO 
	BITCLR(HwGIOCON_B,  Hw6);  //GPIO_B6 input mode setting
	BITSET(HwSEL_B,		Hw2);
	BITSET(HwMSTS_B,	Hw2);
	BITCLR(HwMODE_B,	Hw2);
	BITSET(HwCLR_B,		Hw2); 

	//set low level trigger
	BITCLR(HwICFG, Hw11);	   
	BITSET(HwICFG, Hw10|Hw9);      
#endif

#elif defined(_TCC80x_)
	// PK7 --> EXT7
	BITSET(HwPMIO_FS0, Hw7); // 1 : PK pin controlled by GPIOPK_DAT/DOE/FS0~2 
	BITSET(HwGPIOPK_FS0,Hw7);// External Interrupt Inputs [7:0] to Interrupt Controller 
	BITCLR(HwGPIOPK_DOE,Hw7);// GPIO_PK7 Input mode Setting 
	BITSET(HwGPIOPK_IRQST,Hw7);// Interrupt Status for PK[31:0] 
	BITSET(HwGPIOPK_IRQTM0,Hw7);// Level Trigger

	BITSET(HwGPIOPK_IRQEN,Hw7);// Interrupt Enable for PK[31:0] (0 = Disable, 1 = Enable)

	BITSET(HwPOL_B,Hw7);	// Low Active
	BITSET(HwTMODE_B,Hw7);	// Level
	BITSET(HwSYNC_B,Hw7);	// Sync Disable
#elif defined(CONFIG_ARCH_TCC92X)

#if defined(CONFIG_MACH_TCC9200S)
	//power control
	BITCSET(HwGPIOE->GPFN3, HwPORTCFG_GPFN7_MASK, HwPORTCFG_GPFN7(0));
	HwGPIOE->GPEN	|= Hw31;
	HwGPIOE->GPDAT	|= Hw31;	
#endif

	// Interrupt Control
	BITCLR(TSC_EINT_PORT_EN, TSC_EINT_PIN);  //Input mode
	BITCSET(HwEINTSEL->EINTSEL2, TSC_EINT_SEL_MASK, TSC_EINT_SEL);

	HwPIC->INTMSK0 |= TSC_EINT_SEL_ID;	   

	
	HwPIC->IEN0 	&= ~(TSC_EINT_SEL_ID);						/* disable I2C */
	HwPIC->MODEA0	&= ~(TSC_EINT_SEL_ID) ; 					/* signle edge */

	HwPIC->MODE0	&= ~(TSC_EINT_SEL_ID);						/* set edge trigger mode */	

	HwPIC->POL0 	|= (TSC_EINT_SEL_ID);						/* active-high */
	HwPIC->CLR0 	=  TSC_EINT_SEL_ID; 						/* clear pending status */
	HwPIC->IEN0 	|= (TSC_EINT_SEL_ID);						/* Enable Interrupt */


//  BITSET(HwPOL, HwINT_EI2);
//	BITCLR(HwMODE, HwINT_EI2);

#endif
}



