/*
 * drivers/media/video/tcccam/ov7690_vga.h
 *
 * Register definitions for the ov7690 CameraChip.
 *
 * Author: Byunghoon Mun (joonimbc@telechips.com)
 *
 * Copyright (C) 2010 Telechips, Inc.
 *
 * This file is licensed under the terms of the GNU General Public License 
 * version 2. This program is licensed "as is" without any warranty of any 
 * kind, whether express or implied.
 */
#include <mach/globals.h>
#include "sensor_if.h"

#ifndef OV7690_H
#define OV7690_H

/* The OV7690 I2C sensor chip has a fixed slave address of 0x42. */
#define SENSOR_I2C_ADDR		0x42

#define REG_TERM 0xFF	/* terminating list entry for reg */
#define VAL_TERM 0xFF	/* terminating list entry for val */

//CLOCK
#define CKC_CAMERA_MCLK				240000		
#define CKC_CAMERA_MCLK_SRC			DIRECTPLL1
#define CKC_CAMERA_SCLK				480000
#define CKC_CAMERA_SCLK_SRC			DIRECTPLL1

#define FRAMESKIP_COUNT_FOR_CAPTURE 1

// ZOOM Setting!!
#define PRV_W			640
#define PRV_H			480
#define PRV_ZOFFX		8
#define PRV_ZOFFY		6

#define CAP_W			640
#define CAP_H			480
#define CAP_ZOFFX		8
#define CAP_ZOFFY		6

#define CAM_2XMAX_ZOOM_STEP 	31
#define CAM_CAPCHG_WIDTH  		640


struct sensor_reg {
	unsigned char reg;
	unsigned char val;
};

struct capture_size {
	unsigned long width;
	unsigned long height;
};

extern struct capture_size sensor_sizes[];
extern void sensor_init_fnc(SENSOR_FUNC_TYPE *sensor_func);

#endif /* MV9317_H */

