#ifndef _USB_DEFS_H
#define _USB_DEFS_H


#define OTG_INCLUDE
//#define HwPIC						((PPIC)&(HwPIC_BASE))
//#define HwUSBPHYCFG					((PUSBPHYCFG)&HwUSBPHYCFG_BASE)
//#define HwUSB20OTG					((PUSB20OTG)&HwUSB20OTG_BASE)
//#define HwUSBOTGCFG					((PUSBOTGCFG)&(HwUSBOTGCFG_BASE))


#define USBDEV_VTC_INCLUDE
//#define USBDEV_MSC_INCLUDE

#define USBDEV_DMA_ADDR				0x10000000
#define OUTEP0_DMA_ADDR				USBDEV_DMA_ADDR
#define INEP0_DMA_ADDR				(OUTEP0_DMA_ADDR+64)
#define OUTEP1_DMA_ADDR				(INEP0_DMA_ADDR+64)
#define INEP1_DMA_ADDR				(OUTEP1_DMA_ADDR+512)
#define OUTEP2_DMA_ADDR				(INEP1_DMA_ADDR+512)
#define INEP2_DMA_ADDR				(OUTEP2_DMA_ADDR+512)

//===================================================================
//
//		DRIVER SIGNATURE
//
//===================================================================
#define SIGBYAHONG				'S','I','G','B','Y','A','H','O','N','G','_'

#if defined(_WINCE_)
#define SIGN_OS					'W','I','N','C','E','_'
#elif defined(_LINUX_)
#define SIGN_OS					'L','I','N','U','X','_'
#else
#define SIGN_OS					'N','U','_'
#endif

#if defined(TCC77X)
#define SIGN_CHIPSET			'T','C','C','7','7','X','X','_'
#elif defined(TCC78X)
#define SIGN_CHIPSET			'T','C','C','7','8','X','X','_'
#elif defined(TCC79X)
#define SIGN_CHIPSET			'T','C','C','7','9','X','X','_'
#elif defined(TCC81XX)
#define SIGN_CHIPSET			'T','C','C','8','1','X','X','_'
#elif defined(TCC82XX)
#define SIGN_CHIPSET			'T','C','C','8','2','X','X','_'
#elif defined(TCC83XX)
#define SIGN_CHIPSET			'T','C','C','8','3','X','X','_'
#elif defined(TCC87XX)
#define SIGN_CHIPSET			'T','C','C','8','7','X','X','_'
#elif defined(CONFIG_MACH_TCC8900)
#define SIGN_CHIPSET			'T','C','C','8','9','X','X','_'
#elif defined(TCC91XX)
#define SIGN_CHIPSET			'T','C','C','9','1','X','X','_'
#elif defined(CONFIG_ARCH_TCC9200)
#define SIGN_CHIPSET			'T','C','C','9','1','X','X','_'
#elif defined(CONFIG_ARCH_TCC92X)
#define SIGN_CHIPSET			'T','C','C','9','2','X','X','_'
#else
#error
#endif

#ifndef NULL
#define NULL				0
#endif

#ifndef FALSE
#define FALSE				0
#endif

#ifndef TRUE
#define TRUE				1
#endif

#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

#ifndef dim
#define dim(x) (sizeof(x) / sizeof(x[0]))
#endif

#ifndef BITSET
#define BITSET(X, MASK) 			( (X) |= (unsigned int)(MASK) )
#endif
#ifndef BITSCLR
#define BITSCLR(X, SMASK, CMASK)	( (X) = ((((unsigned int)(X)) | ((unsigned int)(SMASK))) & ~((unsigned int)(CMASK))) )
#endif
#ifndef BITCSET
#define BITCSET(X, CMASK, SMASK)	( (X) = ((((unsigned int)(X)) & ~((unsigned int)(CMASK))) | ((unsigned int)(SMASK))) )
#endif
#ifndef BITCLR
#define BITCLR(X, MASK) 			( (X) &= ~((unsigned int)(MASK)) )
#endif
#ifndef BITXOR
#define BITXOR(X, MASK) 			( (X) ^= (unsigned int)(MASK) )
#endif
#ifndef ISZERO
#define ISZERO(X, MASK) 			(  ! (((unsigned int)(X)) & ((unsigned int)(MASK))) )
#endif

#endif //_USB_DEFS_H
