/*
 *  linux/include/asm-arm/arch-tcc83x/irqs.h
 *
 *  Copyright (C) Telechips 2007
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ASM_ARCH_TCC_IRQS_H
#define __ASM_ARCH_TCC_IRQS_H


/*
 * IRQ A GROUP
 */
#define	INT_INTB	0
#define	INT_BDMA	1
#define	INT_ADMA	2
#define	INT_GDMA1	3
#define	INT_DAIRX	4
#define	INT_DAITX	5
#define	INT_TC0		6
#define	INT_UT0		7	
#define	INT_UD		8 
#define	INT_SPDTX	9
#define	INT_UDMA	10
#define	INT_SD3		11
#define	INT_CAM		12	
#define	INT_DMA		13
#define	INT_TC32	14
#define	INT_LCD		15	
#define	INT_ADC		16	
#define	INT_I2C		17	
#define	INT_RTC_P	18
#define	INT_RTC		19
#define	INT_NFC		20
#define	INT_SD		21
#define	INT_HPI_W	22
#define	INT_HPI		23
#define	INT_UH		24
#define	INT_JPEG	25
#define	INT_G2D		26
#define	INT_ECC		27
#define	INT_SPI_R	28
#define	INT_UT1		29
#define	INT_SC		30

/*
 * IRQ B GROUP
 */
#define IRQ_B_OFFSET	31
#define	INT_EI0 	IRQ_B_OFFSET + 0
#define	INT_EI1		IRQ_B_OFFSET + 1 
#define	INT_EI2		IRQ_B_OFFSET + 2 
#define	INT_EI3		IRQ_B_OFFSET + 3
#define	INT_EI4		IRQ_B_OFFSET + 4
#define	INT_EI5		IRQ_B_OFFSET + 5
#define	INT_EI6		IRQ_B_OFFSET + 6
#define	INT_EI7		IRQ_B_OFFSET + 7
#define	INT_UT2		IRQ_B_OFFSET + 8
#define	INT_UT3		IRQ_B_OFFSET + 9
#define	INT_SPI1_T	IRQ_B_OFFSET + 10
#define	INT_SPI1_R	IRQ_B_OFFSET + 11
#define	INT_SD1D	IRQ_B_OFFSET + 12
#define	INT_SPDIF	IRQ_B_OFFSET + 13
#define	INT_CDIF	IRQ_B_OFFSET + 14
#define	INT_VBON	IRQ_B_OFFSET + 15
#define	INT_VBOFF	IRQ_B_OFFSET + 16

/* IRQA 31 + IRQB 17 */
#define NR_IRQS (INT_SC+1 + INT_VBOFF-IRQ_B_OFFSET+1)


#endif  /* ASM_ARCH_TCC_IRQS_H */

