/*
 * linux/include/asm-arm/plat-tcc/tcc_ckc.h
 *
 * Author:  <linux@telechips.com>
 * Created:     June 10, 2008
 * Description: Telechips Clock Control func headers
 *
 * Copyright (C) 2008-2009 Telechips 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see the file COPYING, or write
 * to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef __TCC_CKC_H__
#define __TCC_CKC_H__

#include <asm/plat-tcc/tca_ckcstr.h>

extern void tca_ckc_setsystemsource( unsigned int ClockSource );
extern int tca_ckc_getsystemsource(void);
extern int tca_ckc_setperibus(unsigned int Controller, unsigned int Mode);
#ifdef CONFIG_ARCH_TCC79X
extern int tca_ckc_setperibusmask( unsigned int Controller, unsigned int Mode);
#endif
extern int tca_ckc_resetperi(unsigned int Controller, unsigned int Mode);
extern unsigned int tca_ckc_currentpll(unsigned int uCH);
extern void tca_ckc_peri(void *upAddr, int ishift, int iSrc, int iDiv);
extern int tca_ckc_setperi(unsigned int pName, unsigned int  nUnit,unsigned int pFreq , unsigned int pSource );
extern int tca_ckc_getperi(unsigned int pName);
extern int tca_ckc_getcurrentsys(void);
extern int tca_ckc_getcurrentbus(void);
extern int tca_ckc_getcurrentcpu(void);
extern int tca_ckc_getcurrentsubcpu(void);
extern void tca_ckc_validpll(unsigned int *pFreq);
extern void tca_ckc_setpll(unsigned char P,unsigned char M,unsigned char S ,unsigned int uCH);
extern void tca_ckc_setmaincpu(unsigned pllVal ,unsigned cpuVal ,unsigned busVal );
extern void tca_ckc_setsubcpu(unsigned pllVal ,unsigned cpuVal ,unsigned busVal );
extern void tca_ckc_setcpu(unsigned pllVal ,unsigned cpuVal ,unsigned busVal );
extern void tca_ckc_setbus(unsigned busVal );
#ifdef CONFIG_ARCH_TCC79X
extern void tca_ckc_minsubcpu(void );
extern void tca_ckc_closesubcpu(void );
extern void tca_ckc_opensubcpu(void );
#endif
extern int tca_ckc_setclock(unsigned int pLL,unsigned  int cPU,unsigned  int bUS,unsigned int uCH);

#define tca_ckc_com_setperibus tca_ckc_setperibus
#define tca_ckc_com_setperi tca_ckc_setperi

#endif /*__TCC_CKC_H__*/

