/*
 * include/linux/mfd/act8810.h
 *
 * Copyright (C) 2009 Telechips, Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __LINUX_MFD_ACT8810_H
#define __LINUX_MFD_ACT8810_H

#include <linux/i2c.h>
#include <linux/platform_device.h>
#include <linux/regulator/act8810.h>

struct act8810 {
	struct i2c_client *client;
	struct mutex lock;

	struct platform_device regulators[ACT8810_NUM_REGULATORS];
};

int act8810_reg_read(struct act8810 *act8810, u8 reg);
int act8810_reg_write(struct act8810 *act8810, u8 reg, u8 val);
int act8810_reg_set_bit_mask(struct act8810 *act8810, u8 reg, u8 mask, u8 val);

#endif
