
#ifndef __TSIF_TCC79X_H__
#define __TSIF_TCC79X_H__

#define TSIF_DEV_MAJOR 252
#define TSIF_DEV_NAME "tsif"
#define TSIF_SPI_NUM 1
#define TSIF_PACKET_SIZE 188
#define PID_MATCH_TABLE_MAX_CNT 32


struct tcc_tsif_param {
    unsigned int ts_total_packet_cnt;
    unsigned int ts_intr_packet_cnt;
    unsigned int mode;
};

struct tcc_tsif_pid_param {
    unsigned int pio_data[PID_MATCH_TABLE_MAX_CNT];
    unsigned int valid_data_cnt;
};


#define IOCTL_TSIF_DMA_START        _IO(TSIF_DEV_MAJOR, 1)
#define IOCTL_TSIF_DMA_STOP         _IO(TSIF_DEV_MAJOR, 2)
#define IOCTL_TSIF_GET_MAX_DMA_SIZE _IO(TSIF_DEV_MAJOR, 3)
#define IOCTL_TSIF_SET_PID          _IO(TSIF_DEV_MAJOR, 4)



#endif /*__TSIF_TCC79X_H__*/

